<?php

namespace Drupal\content_moderation_reviewer;

use Drupal\node\Entity\Node;
use Drupal\node\Entity\NodeType;
use Drupal\TestSite\TestSetupInterface;

class TestSetup implements TestSetupInterface {

  /**
   * {@inheritdoc}
   */
  public function setUp() {

    \Drupal::service('module_installer')->install(['content_moderation', 'node', 'user', 'system']);

    NodeType::create([
      'type' => 'page',
    ])->save();

    Node::create([
      'type' => 'page',
      'title' => 'Test title',
      'moderation_state' => 'draft',
      'status' => 0,
    ])->save();

    \Drupal::service('module_installer')->install(['cmr_test']);

    $user_names = ['test drafter 1', 'test drafter 2', 'test editorial_reviewer 1', 'test editorial_reviewer 2', 'test legal_reviewer 1', 'test legal_reviewer 2'];
    $user_storage = \Drupal::entityTypeManager()->getStorage('user');
    foreach ($user_names as $name) {
      $users = $user_storage->loadMultiple($user_storage->getQuery()->condition('name', $name)->execute());
      $this->users[$name] = reset($users);
    }

    \Drupal::service('account_switcher')->switchTo($this->users['test drafter 1']);
  }

}
