module.exports = {

  before: function(browser) {
    browser
      .drupalInstall({ setupFile: __dirname + '/TestSetup.php' });
  },
  after: function(browser) {
    browser
      .drupalUninstall();
  },
  'Visit the latest revision page': (browser) => {
    browser
      .drupalLoginAsAdmin(() => {
        browser
          .drupalRelativeURL('/node/1');

        browser.expect.element('[name="moderation_state[0][state]"]').value.to.equal('draft');
        browser.expect.element('input[name="content_moderation_reviewer[0][target_id]"]').value.to.equal('');

        // Change to editorial reviewer
        browser.setValue('[name="moderation_state[0][state]"]', 'editorial_review');
        // We pause for the ajax form request to finish
        browser.pause(3000);

        browser.setValue('input[name="content_moderation_reviewer[0][target_id]"]', 't');
        browser.waitForElementPresent('ul.ui-autocomplete li', 3000);
        browser.expect.element('ul.ui-autocomplete li:nth-of-type(1) a').text.to.equal('test editorial_reviewer 1');
        browser.expect.element('ul.ui-autocomplete li:nth-of-type(2) a').text.to.equal('test editorial_reviewer 2');

        browser.setValue('[name="content_moderation_reviewer[0][target_id]"]', 'test editorial_reviewer 1 (4)');
        browser.click('#edit-submit');

        browser.expect.element('[name="moderation_state[0][state]"]').value.to.equal('editorial_review');
        browser.expect.element('input[name="content_moderation_reviewer[0][target_id]"]').value.to.equal('test editorial_reviewer 1 (4)');

        // // Change to legal reviewer
        browser.setValue('[name="moderation_state[0][state]"]', 'legal_review');
        // We pause for the ajax form request to finish
        browser.pause(3000);
        // Ensure changing the moderation state resets the content_moderation_reviewer textfield.
        browser.expect.element('input[name="content_moderation_reviewer[0][target_id]"]').value.to.equal('');

        browser.setValue('[name="content_moderation_reviewer[0][target_id]"]', 't');
        browser.waitForElementPresent('ul.ui-autocomplete li', 3000);
        browser.expect.element('ul.ui-autocomplete li:nth-of-type(1) a').text.to.equal('test legal_reviewer 1');
        browser.expect.element('ul.ui-autocomplete li:nth-of-type(2) a').text.to.equal('test legal_reviewer 2');

        browser.setValue('[name="content_moderation_reviewer[0][target_id]"]', 'test legal_reviewer 1 (6)');
        browser.click('#edit-submit');

        browser.expect.element('[name="moderation_state[0][state]"]').value.to.equal('legal_review');
        browser.expect.element('input[name="content_moderation_reviewer[0][target_id]"]').value.to.equal('test legal_reviewer 1 (6)');

        // Changing to public should hide the content_moderation_reviewer field.
        browser.setValue('[name="moderation_state[0][state]"]', 'published');
        browser.waitForElementNotPresent('input[name="content_moderation_reviewer[0][target_id]"]', 3000);

        browser.click('#edit-submit');
      })
      .end();
  },

};
